#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void high_score(int n,double val) {
	/*
	 * If you detected the biggest spike || gaussian so far, write this
	 * glorious moment on $HOME/seti_highscore.
	 *
	 * This routine could chew up a bit of memory (4 Kb) but I think it
	 * wont't be called too many times per run :-)
	 */
	char dummy[512];
	system("date > /tmp/setidate");
	f1=fopen("/tmp/setidate","r");
	fgets(dummy,512,f1);
	fclose(f1);
	f1=fopen(Hiscore,"a");
	if (n==0) fprintf(f1,"%s%s %f.\n",dummy,_("New big spike"),val);
	if (n==1) fprintf(f1,"%s%s %f.\n",dummy,_("New big gaussian"),val);
	fclose(f1);
	system("rm --force /tmp/setidate");
	}	
	
void getpath(void) {
	/*
	 * This is NOT elegant, neither stable (However, everyone should have
	 * $HOME environement variable correctly set up...). It should scan
	 * passwd database and extract informations... Maybe next time !
	 */
	char *ptr;
	ptr = getenv("HOME");
	sprintf(path,"%s/%s",ptr,setidir);
	sprintf(Path,"%s/%s/state.txt",ptr,setidir);
	sprintf(Uinfo,"%s/%s/user_info.txt",ptr,setidir);
	sprintf(Pref,"%s/.gtkseti",ptr);
	sprintf(Hiscore,"%s/seti_highscore",ptr);
	sprintf(Rcfile,"%s/.gtksetirc",ptr);
	}

int scanstate(gpointer data) {
	char dummy[512],*entry,*value,nome[512]; 
	char l4[256],l5[256],l6[256],title[256],flag[2];
	char l10[256],l11[256],l12[256];
	int hours,minutes,seconds;
	int o_hours,o_minutes,o_seconds;
	long int a,b;
	double bigspike,biggaussian,percent,cpu;
	long double setitime,totaltime;	

	/*
	 * This is the 'main' loop of the program. The code IS a mess, I am 
	 * definitively not good at coding, so you could hate reading below...
	 */

	PID = 0;
	
	/*
	 * This really sucks. I could think something better, like scanning
	 * for directories in /proc, for detecting PID. Anyway, it works.
	 * The major drawback is it can't handle multiple sessions (If you
	 * are running more than one instances of 'setiathome', it will detect
	 * the one with lower PID). As above, should improve it !
	 */
	 
	system("ps x > /tmp/processes");
	if (system("grep setiathome /tmp/processes > /tmp/setipid") != 0) {
		gtk_window_set_title(GTK_WINDOW(principale),_("GtkSeti@Home - Client is not running !"));
		status = KILLED;
		return TRUE;
		}
	f1=fopen("/tmp/setipid","r");
	fscanf(f1,"%d",&PID);
	fclose(f1);
	system("rm --force /tmp/processes");
	system("rm --force /tmp/setipid");
	
	/*
	 * This shouldn't happen :-)
	 */
	
	if (PID == 0) {
		gtk_window_set_title(GTK_WINDOW(principale),_("GtkSeti@Home - Client is not running !"));
		status = KILLED;
		return TRUE;
		}
		
      	/*
      	 * Get exact state of client and infoz for evaluating CPU load.
      	 */
      	 
      	sprintf(nome,"/proc/%d/stat",PID);
	if ((f1=fopen(nome,"r")) == NULL) return 0;
	fscanf(f1,"%s %s %s %s %s %s %s %s %s %s %s %s %s %ld %ld",dummy,dummy\
	,flag,dummy,dummy,dummy,dummy,dummy,dummy,dummy,dummy,dummy,dummy\
	,&a,&b);
	fclose(f1);
	if (!strcmp(flag,"R")) status = RUNNING;
	if (!strcmp(flag,"T")) status = PAUSED;
	if (!strcmp(flag,"S")) status = SLEEPING;
	t1=a+b;
	
	/*
	 * This is not accurate, I should measure dt rather than assume it
	 * is what I suppose it to be (Well, every good physicist should
	 * do it...). Had a lot of trouble with timer conflicting with Gtk.
	 * Should improve it :-)
	 */
	 	
	if (TIMER != 0 && status == RUNNING) cpu=(float)(t1-t2)/dt;	
	
	/*
	 * Rather self-explanatory. Read state file and info file from client.
	 * They carry informations about work completed, time elapsed...
	 */
	 
	if ((f1=fopen(Path,"r")) == NULL) {
		gtk_window_set_title(GTK_WINDOW(principale),_("GtkSeti@Home - Client downloading ?"));
		return TRUE;
		}
	do {
		fscanf(f1,"%s",(char *)&dummy);
		entry=strtok(dummy,"=");
		value=strtok(NULL,"=");
		if (!strcmp(dummy,"cpu")) setitime=strtod(value,0);
		if (!strcmp(dummy,"bs_power")) bigspike=strtod(value,0);
		if (!strcmp(dummy,"bg_score")) biggaussian=strtod(value,0);
		if (!strcmp(dummy,"prog")) percent=strtod(value,0);		
		} while(!feof(f1));
	fclose(f1);

	if ((f1=fopen(Uinfo,"r")) == NULL) {
		gtk_window_set_title(GTK_WINDOW(principale),_("GtkSeti@Home - Client downloading ?"));
		return TRUE;
		}
	do {
		fscanf(f1,"%s",(char *)&dummy);
		entry=strtok(dummy,"=");
		value=strtok(NULL,"=");
		if (!strcmp(dummy,"total_cpu")) totaltime=strtod(value,0);		
		} while(!feof(f1));
	fclose(f1);
	
	overall_time=setitime+totaltime;
	
	history_out=fopen(Pref,"w");
	FILEISOPEN = 1;
	
	/*
	 * This could be better... I'm lazy.
	 */
	
	hours=(int)(setitime/3600.0);
	minutes=(int)((setitime/3600.0-hours)*60.0);
	seconds=(int)(setitime-hours*3600-minutes*60);

	o_hours=(int)(overall_time/3600.0);
	o_minutes=(int)((overall_time/3600.0-o_hours)*60.0);
	o_seconds=(int)(overall_time-o_hours*3600-o_minutes*60);
	
	if (bigspike > overall_bs) {
		overall_bs = bigspike;
		high_score(0,bigspike);
		}
	if (biggaussian > overall_bg) {
		overall_bg = biggaussian;
		high_score(1,biggaussian);
		}
	
	/*
	 * Now let's update infoz on screen.
	 */
	 	
	sprintf(l4,"%dh %d' %d''",hours,minutes,seconds);
	sprintf(l5,"%dh %d' %d''",o_hours,o_minutes,o_seconds);
	sprintf(l6,"%4.6f",bigspike);
	sprintf(l11,"%3.6f",biggaussian);
	sprintf(l10,"%5.6f",overall_bs);
	sprintf(l12,"%3.6f",overall_bg);
	gtk_label_set_text(GTK_LABEL(label4),l4);
	gtk_label_set_text(GTK_LABEL(label5),l5);
	gtk_label_set_text(GTK_LABEL(label6),l6);
	gtk_label_set_text(GTK_LABEL(label11),l11);
	gtk_label_set_text(GTK_LABEL(label10),l10);
	gtk_label_set_text(GTK_LABEL(label12),l12);
	if (percent < 0.0) percent = 0.0;
	if (percent > 1.0) percent = 1.0;
	if (cpu < 0.0) cpu = 0.0;
	if (cpu > 100.0) cpu = 100.0;
	if (status == KILLED) cpu = 0.0; 
	gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar1),percent);
	gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar2),cpu/100.0);
	t2=t1;

	if (PID == 0) {
		gtk_window_set_title(GTK_WINDOW(principale),_("GtkSeti@Home - Client is not running !"));
		status = KILLED;
		fprintf(history_out,"%f\n%f\n%f\n",overall_bg,overall_bs,overall_time);
		fclose(history_out);
		FILEISOPEN = 0;
		return TRUE;
		}
		
	if (PID != 0) {
		if (status == PAUSED) {
			sprintf(flag,"%s",_("Paused"));
			sprintf(title,"GtkSeti@Home - Client PID : %d (%s)",PID,flag);	
			}	
		if (status == RUNNING) {
			sprintf(flag,"%s",_("Running"));
			sprintf(title,"GtkSeti@Home - Client PID : %d (%s)",PID,flag);	
			}
		if (status == SLEEPING) sprintf(title,_("GtkSeti@Home - Client is waiting to connect to server."));
		gtk_window_set_title(GTK_WINDOW(principale),title);
		}
	fprintf(history_out,"%f\n%f\n%f\n",overall_bg,overall_bs,overall_time);
	FILEISOPEN = 0;
	fclose(history_out);
	return TRUE;
	}

/*
 * The rest should be straightforward...
 */

void
on_principale_destroy                  (GtkObject       *object,
                                        gpointer         user_data)
{
if (FILEISOPEN == 1) {
	fclose(history_out);
	FILEISOPEN = 0;
	}
gtk_main_quit();
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
char command[512];
if (status == RUNNING) return;
if (status == KILLED) {
	sprintf(command,"cd %s ; setiathome -email -nice %d > /dev/null &",path,NL);
	system(command);
	}
if (status == PAUSED) {
	sprintf(command,"kill -SIGCONT %d",PID);
	system(command);
	}
status = RUNNING;
}

void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
char command[512];
if (status != RUNNING) return;
sprintf(command,"kill -SIGSTOP %d",PID);
system(command);
status = PAUSED;
}
void

on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
char command[512];
if (status == KILLED) return;
sprintf(command,"kill -9 %d",PID);
system(command);
status = KILLED;
}

void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if (SHOWN != 1) gtk_widget_show(create_hiscore());
SHOWN = 1;
}

void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if (FILEISOPEN == 1) {
	fclose(history_out);
	FILEISOPEN = 0;
	}
gtk_main_quit();
}

void
on_spinbutton1_changed		      (GtkEditable	*editable,
				       gpointer		user_data)
{
char command[512];
NL=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(user_data));
if (status == RUNNING) {
	sprintf(command,"renice %d %d > /dev/null",NL,PID);
	system(command);
	return;
	}
}

void quickly_escape(void){
	/*
	 * Rather minimalist, isn't it ?
	 */
	gtk_main_quit();
	}
	
void
on_hiscore_destroy                  (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_hide(user_data);
SHOWN = 0;
}
	